"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateTimeInformation = void 0;
var _react = require("react");
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _designparams = require("../designparams");
var _Typography = require("../Typography");
var _practicalReactComponentsIcons = require("practical-react-components-icons");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var DateTimeInformationContainer = _styledComponents.default.div.withConfig({
  displayName: "DateTimeInformation__DateTimeInformationContainer",
  componentId: "sc-1pq6wac-0"
})(["color:", ";fill:", ";background-color:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text04();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text04();
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.background00();
});
var DateInfoContainer = _styledComponents.default.div.withConfig({
  displayName: "DateTimeInformation__DateInfoContainer",
  componentId: "sc-1pq6wac-1"
})(["display:flex;align-items:center;min-width:40%;padding-bottom:", ";"], _designparams.spacing.small);
var TimeIcon = (0, _styledComponents.default)(_practicalReactComponentsIcons.ClockIcon).withConfig({
  displayName: "DateTimeInformation__TimeIcon",
  componentId: "sc-1pq6wac-2"
})(["margin-right:", ";"], _designparams.spacing.medium);
var DatetimeIcon = (0, _styledComponents.default)(_practicalReactComponentsIcons.SystemDatetimeIcon).withConfig({
  displayName: "DateTimeInformation__DatetimeIcon",
  componentId: "sc-1pq6wac-3"
})(["margin-right:", ";"], _designparams.spacing.medium);
var DateTimeInformation = _ref4 => {
  var {
    dateTime,
    lang,
    hour12
  } = _ref4;
  // Some locales generate very long texts... using a shorter version for those.
  var month = (0, _react.useMemo)(() => lang === 'pt' || lang === 'es' ? 'short' : 'long', [lang]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(DateTimeInformationContainer, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(DateInfoContainer, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(TimeIcon, {
        height: _designparams.iconSize.medium,
        width: _designparams.iconSize.medium
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
        variant: "page-heading",
        children: dateTime.toLocaleString(lang, _objectSpread({
          hour: 'numeric',
          minute: 'numeric'
        }, hour12 ? {
          hour12
        } : {
          hourCycle: 'h23'
        }))
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(DateInfoContainer, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(DatetimeIcon, {
        height: _designparams.iconSize.medium,
        width: _designparams.iconSize.medium
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
        variant: "page-heading",
        children: dateTime.toLocaleString(lang, {
          year: 'numeric',
          month,
          day: 'numeric',
          weekday: 'short'
        })
      })]
    })]
  });
};
exports.DateTimeInformation = DateTimeInformation;