/**
 * Divider shows a divider line
 */
import { HTMLAttributes } from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
export interface NormalDividerProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * A normal divider has variant `full`
     *
     * Default: `full`
     */
    readonly variant?: 'full';
}
export interface MiddleDividerProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * A middle divider has variant `middle`
     *
     * Default: `full`
     */
    readonly variant: 'middle';
}
export interface InsetDividerProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * An inset divider has variant `inset`
     *
     * Default: `full`
     */
    readonly variant: 'inset';
    /**
     * Only affect to the Divider which has variant="inset".
     * Changes margin-left size.
     *
     * Default: `64`
     */
    readonly insetSize?: number;
}
export declare const Divider: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, NormalDividerProps | MiddleDividerProps | InsetDividerProps, never>;
export {};
