"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Droppable = void 0;
var _react = require("react");
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _practicalReactComponentsIcons = require("practical-react-components-icons");
var _theme = require("../theme");
var _designparams = require("../designparams");
var _Typography = require("../Typography");
var _Icon = require("../Icon");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["onFileChange", "inputLabel", "supportedFormats", "selectedFileName", "className", "onChange"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var DroppableIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Droppable__DroppableIcon",
  componentId: "sc-xb4nkp-0"
})(["align-self:center;display:block;color:", ";background-color:", ";padding:", ";border-radius:", ";margin-bottom:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text00();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.elementPrimary();
}, _designparams.spacing.small, _designparams.shape.radius.small, _designparams.spacing.medium);
var DroppableArea = _styledComponents.default.div.withConfig({
  displayName: "Droppable__DroppableArea",
  componentId: "sc-xb4nkp-1"
})(["", " border:1px dashed ", ";display:flex;flex-direction:column;font-size:", ";justify-content:center;text-align:center;padding:", " ", ";cursor:pointer;&:focus{border:1px solid ", ";outline:none;}"], _ref3 => {
  var {
    isDragging
  } = _ref3;
  return isDragging ? (0, _styledComponents.css)(["background-color:", ";"], _ref4 => {
    var {
      theme
    } = _ref4;
    return theme.color.background02();
  }) : undefined;
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.text02();
}, _theme.font.size.small, _designparams.spacing.large, _designparams.spacing.extraLarge, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.textPrimary();
});
var DroppableInputFile = _styledComponents.default.input.withConfig({
  displayName: "Droppable__DroppableInputFile",
  componentId: "sc-xb4nkp-2"
})(["display:none;"]);
var DroppableLabel = _styledComponents.default.div.withConfig({
  displayName: "Droppable__DroppableLabel",
  componentId: "sc-xb4nkp-3"
})(["display:grid;grid-gap:", ";grid-template-columns:auto auto;justify-content:center;overflow:hidden;position:relative;color:", ";"], _designparams.spacing.small, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.text01();
});
var InputLabel = (0, _styledComponents.default)(_Typography.Typography).withConfig({
  displayName: "Droppable__InputLabel",
  componentId: "sc-xb4nkp-4"
})(["white-space:initial;word-wrap:break-word;"]);
var enterTarget;
var Droppable = _ref8 => {
  var {
      onFileChange,
      inputLabel,
      supportedFormats,
      selectedFileName,
      className,
      onChange
    } = _ref8,
    props = _objectWithoutProperties(_ref8, _excluded);
  var [isDragging, setDragging] = (0, _react.useState)(false);
  var fileRef = (0, _react.useRef)(null);
  var handleLinkClick = (0, _react.useCallback)(() => {
    var _fileRef$current;
    return (_fileRef$current = fileRef.current) === null || _fileRef$current === void 0 ? void 0 : _fileRef$current.click();
  }, [fileRef]);
  var handleFile = (0, _react.useCallback)(files => {
    if (files === null) {
      return;
    }
    onFileChange === null || onFileChange === void 0 ? void 0 : onFileChange(files[0]);
    if (fileRef.current !== null) {
      fileRef.current.value = '';
    }
  }, [fileRef, onFileChange]);
  var handleDragAndDrop = (0, _react.useCallback)(event => {
    event.preventDefault();
    if (event.type === 'dragenter') {
      enterTarget = event.target;
      setDragging(true);
    }
    if (event.type === 'dragleave' && enterTarget === event.target) {
      event.stopPropagation();
      setDragging(false);
    }
    if (event.type === 'drop') {
      enterTarget = undefined;
      handleFile([...event.dataTransfer.files]);
      setDragging(false);
    }
  }, [handleFile]);
  var handleFileChange = (0, _react.useCallback)(e => {
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    handleFile(e.target.files !== null ? [...e.target.files] : null);
  }, [handleFile, onChange]);
  var handleKeyUp = (0, _react.useCallback)(e => {
    switch (e.key) {
      case 'Enter':
        {
          handleLinkClick();
          break;
        }
    }
  }, [handleLinkClick]);
  var hasSelectedFile = selectedFileName !== undefined;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(DroppableArea, {
    isDragging: isDragging,
    draggable: false,
    onDragEnter: handleDragAndDrop,
    onDragLeave: handleDragAndDrop,
    onDragOver: handleDragAndDrop,
    onDrop: handleDragAndDrop,
    onClick: handleLinkClick,
    className: className,
    tabIndex: 0,
    onKeyUp: handleKeyUp,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(DroppableIcon, {
      icon: _practicalReactComponentsIcons.DropIcon
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(DroppableInputFile, _objectSpread({
      ref: fileRef,
      type: "file",
      multiple: false,
      onChange: handleFileChange
    }, props)), /*#__PURE__*/(0, _jsxRuntime.jsx)(DroppableLabel, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(InputLabel, {
        variant: hasSelectedFile ? 'caption' : 'group-title',
        children: inputLabel
      })
    }), supportedFormats !== undefined && !hasSelectedFile ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
      variant: "caption",
      children: supportedFormats
    }) : null, selectedFileName !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
      variant: !hasSelectedFile ? 'group-title' : 'caption',
      children: selectedFileName
    }) : null]
  });
};
exports.Droppable = Droppable;