import { AnchorHTMLAttributes, ButtonHTMLAttributes, FC, ReactNode } from 'react';
declare type BaseElement = HTMLAnchorElement;
declare type BaseProps = AnchorHTMLAttributes<BaseElement>;
declare type BaseButtonElement = HTMLButtonElement;
declare type BaseButtonProps = ButtonHTMLAttributes<BaseButtonElement>;
export interface ButtonLinkProps extends BaseButtonProps {
    readonly children?: ReactNode;
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseButtonProps['className'];
    /**
     * If `button` it use <button> tag.
     * <button> tag is better than <span> tag for accessibility.
     */
    readonly variant: 'button';
}
export interface ALinkProps extends BaseProps {
    readonly children?: ReactNode;
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * If `a` it use <a> tag and href is required.
     */
    readonly variant: 'a';
}
export declare const Link: FC<ButtonLinkProps | ALinkProps>;
export {};
