"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SubmenuIcon = exports.MenuItem = exports.Menu = void 0;
var _react = require("react");
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _practicalReactComponentsIcons = require("practical-react-components-icons");
var _designparams = require("../designparams");
var _Typography = require("../Typography");
var _Icon = require("../Icon");
var _BaseMenu = require("./BaseMenu");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["icon", "items", "compact"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var SubmenuArrowIcon = () => /*#__PURE__*/(0, _jsxRuntime.jsx)("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24",
  children: /*#__PURE__*/(0, _jsxRuntime.jsx)("path", {
    d: "M11.71 15.29l2.59-2.59a.996.996 0 000-1.41L11.71 8.7c-.63-.62-1.71-.18-1.71.71v5.17c0 .9 1.08 1.34 1.71.71z"
  })
});
var SubmenuIcon = (0, _styledComponents.default)(_Icon.Icon).attrs({
  icon: SubmenuArrowIcon
}).withConfig({
  displayName: "Menu__SubmenuIcon",
  componentId: "sc-7nai50-0"
})(["color:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text05();
});
exports.SubmenuIcon = SubmenuIcon;
var MenuItem = _styledComponents.default.div.withConfig({
  displayName: "Menu__MenuItem",
  componentId: "sc-7nai50-1"
})(["display:grid;align-items:center;grid-template-columns:", ";padding:", ";height:", ";border-bottom:", ";", ""], _ref2 => {
  var {
    hasIcon
  } = _ref2;
  return hasIcon ? "".concat(_designparams.componentSize.small, " 1fr ").concat(_designparams.componentSize.mini) : "1fr ".concat(_designparams.componentSize.mini);
}, _ref3 => {
  var {
    submenu
  } = _ref3;
  return submenu ? "0 ".concat(_designparams.spacing.medium, " 0 ").concat(_designparams.spacing.large) : "0 ".concat(_designparams.spacing.large);
}, _ref4 => {
  var {
    compact
  } = _ref4;
  return compact ? _designparams.componentSize.small : _designparams.componentSize.medium;
}, _ref5 => {
  var {
    divider,
    theme
  } = _ref5;
  return divider === true ? "1px solid ".concat(theme.color.element12()) : 0;
}, _ref6 => {
  var {
    danger,
    theme
  } = _ref6;
  return danger === true ? (0, _styledComponents.css)(["color:", ";"], theme.color.textError()) : undefined;
});
exports.MenuItem = MenuItem;
var MenuItemIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Menu__MenuItemIcon",
  componentId: "sc-7nai50-2"
})(["color:", ";"], _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.text05();
});
/**
 * Menu
 *
 * Forwards props to BaseMenu
 */
var Menu = /*#__PURE__*/(0, _react.memo)(_ref8 => {
  var {
      icon: buttonIcon = _practicalReactComponentsIcons.MoreVertIcon,
      items,
      compact: compactFromProps
    } = _ref8,
    props = _objectWithoutProperties(_ref8, _excluded);
  var {
    compact: compactFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;
  var button = /*#__PURE__*/(0, _jsxRuntime.jsxs)(_BaseMenu.MenuButtonIconContainer, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseMenu.MenuButtonIcon, {
      icon: buttonIcon
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseMenu.MenuButtonHalo, {})]
  });

  /**
   * Creates array of components using MenuItem to
   * forward to Base Menu
   */
  var components = (0, _react.useMemo)(() => items.map(item => {
    var {
      icon,
      label,
      divider,
      danger,
      submenu
    } = item;
    var menuItemContent = icon !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(MenuItemIcon, {
      icon: icon,
      size: "small"
    }) : undefined;
    var submenuArrowIcon = submenu !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(SubmenuIcon, {}) : undefined;
    var submenuComponents = submenu !== undefined ? submenu.map(sub => {
      return _objectSpread({
        component: /*#__PURE__*/(0, _jsxRuntime.jsxs)(MenuItem, {
          divider: sub.divider,
          danger: sub.danger,
          compact: compact,
          submenu: false,
          hasIcon: sub.icon !== undefined,
          children: [sub.icon !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(MenuItemIcon, {
            icon: sub.icon,
            size: "small"
          }) : undefined, /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
            variant: "navigation-label",
            children: sub.label
          })]
        })
      }, sub);
    }) : undefined;
    return _objectSpread({
      component: /*#__PURE__*/(0, _jsxRuntime.jsxs)(MenuItem, {
        divider: divider,
        danger: danger,
        compact: compact,
        submenu: submenu !== undefined,
        hasIcon: icon !== undefined,
        children: [menuItemContent, /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
          variant: "navigation-label",
          children: label
        }), submenuArrowIcon]
      }),
      submenuComponents
    }, item);
  }), [compact, items]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseMenu.BaseMenu, _objectSpread({
    button: button,
    components: components
  }, props));
});
exports.Menu = Menu;
Menu.displayName = 'Menu';