"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Progress = void 0;
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _Typography = require("../Typography");
var _designparams = require("../designparams");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["value", "label"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var ProgressContainer = _styledComponents.default.div.withConfig({
  displayName: "Progress__ProgressContainer",
  componentId: "sc-o1pri3-0"
})(["display:flex;align-items:center;width:100%;"]);
var ProgressIndicator = _styledComponents.default.div.withConfig({
  displayName: "Progress__ProgressIndicator",
  componentId: "sc-o1pri3-1"
})(["position:relative;background-color:", ";border-radius:", ";height:5px;flex-grow:1;overflow:hidden;"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.element12();
}, _designparams.shape.radius.medium);
var ProgressMeter = _styledComponents.default.div.withConfig({
  displayName: "Progress__ProgressMeter",
  componentId: "sc-o1pri3-2"
})(["background-color:", ";border-radius:inherit;height:100%;width:", ";"], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.elementPrimary();
}, _ref3 => {
  var {
    fraction
  } = _ref3;
  return "".concat(Math.round(fraction * 100), "%");
});
var ProgressLabel = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "Progress__ProgressLabel",
  componentId: "sc-o1pri3-3"
})(["padding:0 ", ";color:", ";"], _designparams.spacing.medium, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.text03();
});
var Progress = _ref5 => {
  var {
      value,
      label
    } = _ref5,
    props = _objectWithoutProperties(_ref5, _excluded);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(ProgressContainer, _objectSpread(_objectSpread({}, props), {}, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ProgressIndicator, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ProgressMeter, {
        fraction: value
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ProgressLabel, {
      children: label
    })]
  }));
};
exports.Progress = Progress;