import { HTMLAttributes, FC } from 'react';
import { StepContent, StepperAction } from './Step';
export { StepContent, StepperAction, StepLabel } from './Step';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
export interface StepperProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * The steps passed to the stepper.
     */
    readonly steps: ReadonlyArray<StepContent>;
    /**
     * The function that run on action button click in the last stepper step.
     */
    readonly completeAction: StepperAction;
    /**
     * The function that runs on previous button click.
     */
    readonly prevAction: StepperAction;
    /**
     * The function that runs on next button click.
     */
    readonly nextAction: StepperAction;
    /**
     * The function that runs on reset button click.
     */
    readonly resetAction: StepperAction;
}
export declare const Stepper: FC<StepperProps>;
