import { SimpleToast, ActionToast, ProgressToast, BaseToastValue } from './context';
export declare const ToastLabel: import("styled-components").StyledComponent<"p", import("styled-components").DefaultTheme, import("../Typography").TypographyProps & {
    variant: string;
} & {
    readonly hasCloseButton: boolean;
    readonly isError: boolean;
    readonly hasEmphasis: boolean;
}, "variant">;
export declare enum ToastIconType {
    SUCCESS = "success",
    WARNING = "warning",
    INFO = "info",
    ERROR = "error",
    ACTION = "action"
}
export declare const ToastIconWrapper: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {
    readonly iconType?: ToastIconType | undefined;
}, never>;
export declare const ToastMessage: import("styled-components").StyledComponent<"p", import("styled-components").DefaultTheme, import("../Typography").TypographyProps & {
    variant: string;
}, "variant">;
export declare type Toast = SimpleToast | ActionToast;
declare type ToastCreator<T = Toast> = (toast: T) => BaseToastValue;
declare type SimpleToastCreator = ToastCreator<SimpleToast>;
declare type ActionToastCreator = ToastCreator<ActionToast>;
declare type ProgressToastCreator = ToastCreator<ProgressToast>;
export declare const createSuccessToast: SimpleToastCreator;
export declare const createErrorToast: SimpleToastCreator;
export declare const createWarningToast: SimpleToastCreator;
export declare const createInfoToast: SimpleToastCreator;
export declare const createActionToast: ActionToastCreator;
export declare const createLoadingToast: SimpleToastCreator;
export declare const createProgressToast: ProgressToastCreator;
export {};
