"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FoldTransition = void 0;
var _react = require("react");
var _reactTransitionGroup = require("react-transition-group");
var _jsxRuntime = require("react/jsx-runtime");
var FOLD_ANIMATION_DURATION = 250;
var transitionHeight = (node, start, end) => {
  node.style.overflow = 'hidden';
  node.style.height = "".concat(start, "px");
  /* eslint-disable-next-line no-self-assign */
  node.scrollTop = node.scrollTop; // ✨ force reflow ✨
  node.style.transition = "height ".concat(FOLD_ANIMATION_DURATION, "ms ease-in-out");
  node.style.height = "".concat(end, "px");
};
var FoldTransition = _ref => {
  var {
    expanded,
    children
  } = _ref;
  var nodeRef = (0, _react.useRef)(null);
  var increaseHeight = (0, _react.useCallback)(() => {
    if (nodeRef.current === null) {
      return;
    }
    var node = nodeRef.current;
    var height = node.offsetHeight;
    transitionHeight(node, 0, height);
  }, []);
  var decreaseHeight = (0, _react.useCallback)(() => {
    if (nodeRef.current === null) {
      return;
    }
    var node = nodeRef.current;
    var height = node.offsetHeight;
    transitionHeight(node, height, 0);
  }, []);
  var resetHeight = (0, _react.useCallback)(() => {
    if (nodeRef.current === null) {
      return;
    }
    var node = nodeRef.current;
    node.style.overflow = 'visible';
    node.style.height = 'auto';
    node.style.removeProperty('transition');
  }, []);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactTransitionGroup.TransitionGroup, {
    component: null,
    children: expanded ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactTransitionGroup.Transition, {
      nodeRef: nodeRef,
      appear: true,
      timeout: FOLD_ANIMATION_DURATION,
      onEnter: increaseHeight,
      onEntered: resetHeight,
      onExit: decreaseHeight,
      onExited: resetHeight,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        ref: nodeRef,
        children: children
      })
    }) : undefined
  });
};
exports.FoldTransition = FoldTransition;