"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.twoLinesClamp = void 0;
var _styledComponents = require("styled-components");
/**
 * A styled-components mixin that truncates two-lines text with ellipsis.
 *
 * An example:
 * ```tsx
 * const Div = styled.div`
 *   ${twoLinesClamp};
 * `
 * ```
 */
var twoLinesClamp = (0, _styledComponents.css)(["display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;-moz-box-orient:vertical;overflow:hidden;white-space:pre-wrap;"]);
exports.twoLinesClamp = twoLinesClamp;